<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

class plg_entry	{
	
	
	function icon_display()
	{
		
		$html = '<a href="index.php?option=com_joomd&view=entry&task=add&cid[]=0"><img src="components/com_joomd/assets/images/icon-48-entry-add.png" alt="Entry" /><span>'. JText::_('ADDAENTRY').'</span></a>';
		
		return $html;
		
	}
	
	function getConfig()
	{
		$db =& JFactory::getDBO();
		$query = 'select * from #__joomd_econfig';
		$db->setQuery( $query );
		$config = $db->loadAssoc();
		
		$params = json_decode($config['params']);
		
		$config['params'] = null;
		
		$config['params']->print = isset($params->print)?$params->print:null;
		$config['params']->pdf = isset($params->pdf)?$params->pdf:null;
		$config['params']->email = isset($params->email)?$params->email:null;
		
		return $config;
		
	}
	
	function panel_display()
	{
		
		require_once(JPATH_SITE.'/components/com_joomd/libraries/classes/fields.php');
		
		$this->_field = new JoomdFields('entry');
		
		$db =& JFactory::getDBO();
		
		$query = 'select id, hits from #__joomd_entry order by id desc limit 5';
		$db->setQuery( $query );
		$items = $db->loadObjectList();
		
		$firstfield = $this->_field->get_firstfield(array('core'=>false, 'type'=>1));
		
		$html = '<table class="adminlist">';
		
		$html .= '<tr><th>'.$firstfield->name.'</th><th>'.JText::_('HITS').'</th></tr>';
		
		for($i=0;$i<count($items);$i++)	{
			
			$value = $this->_field->getfieldvalue($items[$i]->id, $firstfield->id, true);
			
			$html .= '<tr><td>'.$value.'</td><td>'.$items[$i]->hits.'</td></tr>';
			
		}
		
		$html .= '</table>';
		
		return $html;
		
	}
	
	function config_display()
	{
		
		$db =& JFactory::getDBO();
		
		$query = 'select * from #__joomd_econfig';
		$db->setQuery( $query );
		$config = $db->loadObject();
		
		$params = json_decode($config->params);
		
		$print = isset($params->print)?$params->print:null;
		$pdf = isset($params->pdf)?$params->pdf:null;
		$email = isset($params->email)?$params->email:null;
		
		ob_start();
		
		?>
        	<fieldset class="adminform">
				<legend><?php echo JText::_( 'ENTRYCONFIG' ); ?></legend>
        	<table class="admintable">
            	
                <tr>
                    <td class="key" style="width:300px;"><?php echo JText::_('USERREGREQ'); ?>:</td>
                    <td><input type="checkbox" name="registration" id="registration" <?php if($config->registration) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_USERREGISTER'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('AUTOMATAPPENTRY'); ?>:</td>
                    <td><input type="checkbox" name="approve" id="approve" <?php if($config->approve) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_APPROVE'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('NOTIFY_ENTRY_OWNER'); ?>:</td>
                    <td><input type="checkbox" name="notify" id="notify" <?php if($config->notify) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_NOTIFY'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('SHOWHEAD'); ?>:</td>
                    <td><input type="checkbox" name="header" id="header" <?php if($config->header) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_HEADER'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('MOREINFOBUTT'); ?>:</td>
                    <td><input type="checkbox" name="button" id="button" <?php if($config->button) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_MORE_BUTTON'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('PRIVATEACCQVELL'); ?>:</td>
                    <td><input type="checkbox" name="list" id="list" <?php if($config->list) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_LIST_ACCESS'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('PACCTOSINENTRYEDV'); ?>:</td>
                    <td><input type="checkbox" name="detail" id="detail" <?php if($config->detail) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_DETAIL_ACCESS'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('PRINTI'); ?>:</td>
                    <td><input type="checkbox" name="params[print]" id="paramsprint" <?php if($print) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_PRINT_ICON'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('PDGI'); ?>:</td>
                    <td><input type="checkbox" name="params[pdf]" id="paramspdf" <?php if($pdf) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_PDF_ICON'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
                <tr>
                    <td class="key"><?php echo JText::_('EMAILI'); ?>:</td>
                    <td><input type="checkbox" name="params[email]" id="paramsemail" <?php if($email) echo 'checked="checked"'; ?> />&nbsp;<span class="hasTip" title="<?php echo JText::_('CONFIG_ENTRY_EMAIL_ICON'); ?>"><img src="components/com_joomd/assets/images/icon-16-info.png" border="0" alt="<?php echo JText::_('INFO'); ?>" align="top" /></td>
            	</tr>
            
            </table>
          </fieldset>
        <?php
		
		$html = ob_get_contents();
		
		ob_clean();
		
		return $html;
		
	}
	
	function config_save($post, $parent)
	{
		
		$db =& JFactory::getDBO();
		
		$post = JRequest::get('post');
		
		$registration = isset($post['registration'])?1:0;
		$approve = isset($post['approve'])?1:0;
		$notify = isset($post['notify'])?1:0;
		$header = isset($post['header'])?1:0;
		$button = isset($post['button'])?1:0;
		$list = isset($post['list'])?1:0;
		$detail = isset($post['detail'])?1:0;
		
		$params	= JRequest::getVar('params', array(), 'post', 'array');
		
		$params['print'] = isset($params['print'])?1:0;
		$params['pdf'] = isset($params['pdf'])?1:0;
		$params['email'] = isset($params['email'])?1:0;
		
		
		$insert = new stdClass();
		
		$insert->id				= 1;
		$insert->registration	= $registration;
		$insert->approve		= $approve;
		$insert->notify			= $notify;
		$insert->header			= $header;
		$insert->button			= $button;
		$insert->list			= $list;
		$insert->detail			= $detail;
		$insert->params			= json_encode($params);
		
		if(!$db->updateObject('#__joomd_econfig', $insert, 'id'))	{
			$parent->setError($db->stderr());
			return false;
		}
		
		return true;
		
	}
	
}