<?php
/**
 * Joomla! component SimpleLists
 *
 * @author Yireo
 * @package SimpleLists
 * @copyright Copyright (C) 2011
 * @license GNU Public License
 * @link http://www.yireo.com/
 */

// Require the Yireo helper
require_once JPATH_COMPONENT.DS.'lib'.DS.'helper.php';

// Initialize the ACLs
SimpleListsHelperAcl::init();

/*
 * Helper for ACL-permissions
 */
class SimpleListsHelperAcl
{
    /*
     * Initialize the helper-class
     *
     * @param mixed $string
     * @return string
     */
    public static function init()
    {
        // Joomla! 1.5 ACLs
        if(YireoHelper::isJoomla15()) {
            $auth =& JFactory::getACL();
            $auth->addACL('com_simplelists', 'manage', 'users', 'super administrator');
            $auth->addACL('com_simplelists', 'manage', 'users', 'administrator');
            $auth->addACL('com_simplelists', 'manage', 'users', 'manager');
        }
    }

    /*
     * Check whether a certain person is authorized
     *
     * @param mixed $string
     * @return string
     */
    public static function isAuthorized()
    {
        // Initialize system variables
        $user =& JFactory::getUser();

        // Check the ACLs for Joomla! 1.5
        if(SimpleListsHelperCore::isJoomla15() && !$user->authorize( 'com_simplelists', 'manage' )) {
            return false;

        // Check the ACLs for Joomla! 1.6 and later
        } elseif(SimpleListsHelperCore::isJoomla16() && !$user->authorize( 'com_simplelists.manage' )) {
            return false;
        }

        return true;
    }
}

