<?php

/*------------------------------------------------------------------------
# com_joomd - Joomd Manager
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class JoomdControllerEntrypanel extends JoomdController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		
		parent::__construct();
		
		require_once(JPATH_COMPONENT.'/libraries/classes/fields.php');
		
		$this->config = Joomd::getConfig('entry');
		$this->user = Joomd::getUser('entry');
		
		$this->getTypeid();
		
		$this->checkAccess();
		
		$this->field = new JoomdFields('entry');
		
		$this->field->checkType();
		
		$this->registerTask( 'add',	'edit' );
		$this->registerTask( 'apply',	'save' );
		
	}
	
	//to check the access level of individual entry/in configuration/by type/by category
	function checkAccess()
	{
		
		//to check the assigned type and it's access level
		$this->_type = Joomd::getType();
		
		$layout	= JRequest::getCmd('layout', '');
		$task	= JRequest::getCmd('task', '');
		
		if($layout == "form")
			$task = 'add';
			
		if($this->user->get('guest') and ($this->config->registration or ($layout <> "form" and $task <> "add" and $task <> "loadfields")))	{
			Joomd::redirect(JRoute::_('index.php?option='.COM_USER.'&view=login&return='.base64_encode(JRoute::_('index.php?option=com_joomd&view=entrypanel&typeid='.$this->_type->id))), JText::_('PLSLOGTOACC'));
			return;
		}
		
	}
	
	//to get typeid if itemid is there
	function getTypeid()
	{
		$typeid = JRequest::getInt('typeid', 0);
		$itemid = JRequest::getInt('id', 0);
		
		if(!$typeid and $itemid)	{
			$model = $this->getModel('entrypanel');
			$item = $model->getItem();
			
			JRequest::setVar('typeid', $item->typeid);
		}
		
		
	}
	
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		
		JRequest::setVar( 'view', 'entrypanel'  );
		JRequest::setVar( 'layout', 'form'  );
		
		$html = parent::edit();
		
		jexit($html);
		
	}
	
	function save()
	{
		$model = $this->getModel('entrypanel');
		
		$obj = $model->store();
		
		jexit(json_encode($obj));

	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function delete()
	{
		$model = $this->getModel('entrypanel');
		
		if($model->delete())	{
						
			$msg = JText::_('ENTRYREVSUCC');
			
			$data = $this->getItems();
			
			$json->result = "success";
			$json->msg = $msg;
			$json->error = $model->getError();
			$json->html = $data->html;
			$json->count = $data->count;
			$json->total = $data->total;
			
		}
		else	{
			$json->result = "error";
			$json->msg = '';
			$json->error = $model->getError();
			
		}
		
		jexit(json_encode($json));

	}
	
	function getItems()
	{
		
		$model = $this->getModel('entrypanel');
		
		$layout = JRequest::getCmd('layout', 'default');
		
		$items = $model->getItems();
		$params = $model->getParams();
		
		$this->firstfield =& $this->field->get_firstfield(array('core'=>false));
		
		ob_start();
		
		$now =& JFactory::getDate();
						
		$k = 0;
		$i = $params->limitstart;
		for ($n=0; $n < count( $items ); $n++)
		{
			$row =& $items[$n];
			
			$path = Joomd::getTemplatePath('entrypanel', $layout.'_item.php');
			
			require($path);
			
			$k = 1 - $k;
			$i++;
			
		}
		
		$html = ob_get_contents();
		
		ob_end_clean();
		
		$data->html = $html;
		$data->count = count($items);
		$data->total = $params->total;
		
		return $data;
		
	}
	
	function loaditems()
	{
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( '{"result":"error", "error":"'.JText::_('INVALIDTOKEN').'"}' );
		
		$data = $this->getItems();
		
		$json->result = "success";
		$json->html = $data->html;
		$json->count = $data->count;
		$json->total = $data->total;
		
		jexit(json_encode($json));
	
	}
	
	function loadfields()
	{
		
		$cats = JRequest::getVar( 'catid', array(), 'post', 'array' );
		$id = JRequest::getInt('id', 0);
		
		$html = $this->field->loadformfields($id, array('cats'=>$cats, 'form'=>'editform'));
		
		jexit($html);
		
	}
	
	function delete_custom()
	{
		
		$model = $this->getModel('entrypanel');
		
		if($model->delete_custom())	{
			$msg = JText::_('IMAGEDELETESUCCESS');
			jexit('{"result":"success", "msg":"'.$msg.'"}');
		}
		else	{
			
			jexit('{"result":"error", "error":"'.$model->getError().'"}');
			
		}
		
	}

}