<?php
 
/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/
 
// No direct access
 
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport( 'joomla.application.component.model' );
 
class JoomdModelEntry extends JModel
{
	
	function __construct()
	{
		parent::__construct();
 
        $mainframe =& JFactory::getApplication();
		
		$context			= 'com_joomd.entry.list.'; 
        // Get pagination request variables
        $this->_limit = JRequest::getInt('limit', $mainframe->getCfg('list_limit'));
		$this->_limitstart = JRequest::getInt('limitstart', 0 );
 
        // In case limit has been changed, adjust it
        $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
		
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		
		//get the order by from the menu parameters
		$params = $mainframe->getParams();
		
		if(is_object($menu))	{
		if(!strstr($menu->link, 'view=entry'))
			$params->set('orderby', 'ordering asc');
		}
		
		$orderby = explode(' ', $params->def('orderby', 'ordering asc'));

		
		$orderby[1] = isset($orderby[1])?$orderby[1]:'';
		
		$this->_filter_order	= $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', $orderby[0], 'cmd' );
        $this->_filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', $orderby[1], 'word' );
		$this->_filter_search = $mainframe->getUserStateFromRequest( $context.'filter_search', 'filter_search', '',	'string' );
		$this->_filter_search = JString::strtolower( $this->_filter_search );
		
		$this->_typeid = $mainframe->getUserStateFromRequest( $context.'typeid', 'typeid', 1,	'int' );
				
		$this->_catid = JRequest::getInt('catid', 0);
		$this->Itemid = JRequest::getVar('Itemid', '');
		
		$this->_user = Joomd::getUser();
		
		$this->config =& Joomd::getConfig('entry');
				
		$this->_field = new JoomdFields('entry');
		
		$this->setId();

	}
	
	function setId()
	{
				 
		$id = JRequest::getInt('id', 0);
		
		$layout = JRequest::getCmd('layout', '');
		
		if($layout == "detail")	{
			
			if(!$id)
				Joomd::redirect('index.php?option=com_joomd&view=entry', JText::_('NOEF'));
				
			$query = 'update #__joomd_entry set hits = hits + 1 where id = ' . $id;
			$this->_db->setQuery( $query );
			$this->_db->query();	
		
		}
		
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	
	function getUser()
	{
		
		return Joomd::getUser();
		
	}
	
	function _buildQuery()
	{
		
		$query = 'select * from #__joomd_entry ';

		return $query;
		
	}
	
	function getItem()
	{
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'.DS.'tables');
		$row =& JTable::getInstance('entry', 'Table');
		
		$item = $row->loadentry($this->_id);
		
		$this->_typeid = $item->typeid;
		
		return $item;
	
	}
	
	function &getItems()
    {
        if(empty($this->_data))	{
		
			$query = $this->_buildQuery();
			
			$filter = $this->_buildItemFilter();
			$query .= $filter;
			$orderby = $this->_buildItemOrderBy();
			$query .= $orderby;
			
			$this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
			
		}

        return $this->_data;
    
	}
	
	function _buildItemFilter()
	{
 
        $where = array();
		
		$where[] = 'published = 1';
		
		if(JD_VERSION == 15)
			$where[] = 'access <= '.(int)$this->_user->aid;
		else
			$where[] = 'access in ('.implode(',', $this->_user->getAuthorisedViewLevels()).')';
		
		$where[] = 'typeid = '.$this->_typeid;
		
		if($this->_catid)	{
			
			$query = 'select itemid from #__joomd_entry_cat where catid = '.$this->_catid;
			$this->_db->setQuery( $query );
			$entries = $this->_db->loadResultArray();
			
			$where[] = count($entries)?'id in ('.implode(', ', $entries).')':'id=0';
			
		}
					
		$filter = ' where ' . implode(' and ', $where);
 
        return $filter;
	}
	
	function _buildItemOrderBy()
	{
 
        $orderby = ' group by id order by '.$this->_filter_order.' '.$this->_filter_order_Dir;
 
        return $orderby;
	}
	
	function getParams()
  	{	
		
		$layout = JRequest::getCmd('layout', 'default');
		
		$this->item->option = 'com_joomd';
		$this->item->view = 'entry';
		$this->item->abase = 1;
		$this->item->task = '';
		$this->item->typeid = $this->_typeid;
		$this->item->catid = $this->_catid;
		$this->item->Itemid = $this->Itemid;
		
		if($layout <> "detail")	{
			
			$this->item->limit = $this->_limit;
			$this->item->limitstart = $this->_limitstart;
			$this->item->filter_search = $this->_filter_search;
			$this->item->filter_order = $this->_filter_order;
			$this->item->filter_order_Dir = $this->_filter_order_Dir;
			
			// Load the plugin if it doesn't already exist
			if (empty($this->_total)) {
				$query = $this->_buildQuery();
				$filter = $this->_buildItemFilter();
				$query .= $filter;
				$orderby = $this->_buildItemOrderBy();
				$query .= $orderby;
				$this->item->total = (int) $this->_getListCount($query);    
			}
		
		}
		
        return $this->item;
  	}
	
	function getCategory()
	{
		
		if($this->_catid)	{
			
			$query = 'select * from #__joomd_category where published = 1 and id = '.$this->_catid;
			$this->_db->setQuery( $query );
			$item = $this->_db->loadObject();
			
			return $item;
			
		}
		
	}
	
	function checkCategoryAccess($id=null)
	{
		
		$id = empty($id)?$this->_id:(int)$id;
		
		$query = 'select * from #__joomd_category where id in ( select catid from #__joomd_entry_cat where itemid = '.$id.' )';
		$this->_db->setQuery( $query );
		$items = (array)$this->_db->loadObjectList();
		
		if(count($items) == 1)	{
			return Joomd::CanAccessItem($items[0]);
		}
		
		foreach($items as $item)	{
			
			if(Joomd::CanAccessItem($item))
				return true;
			
		}
		
		return false;
		
	}
	
}
